// iqRotat.cpp: dfinit le point d'entre pour l'application console.
//

#include "stdafx.h"
#ifdef linux
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>

#include <errno.h>
#include <math.h>
#include <float.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <unistd.h>
#endif


double monRand(double x)
{
	return (rand() * x) / RAND_MAX;
}


int randomVarCirc180()
{
	return (int)(floor(monRand(180.0))) - 90;
}

int randomVarCirc4fromTab(int idb)
{
	int myRef[4] = { 94 - 180, 62, -7, 25 };
	return myRef[(int)(idb + floor(monRand(2.0)))];
}

void exitHelp()
{
	printf("outputs random rotations  from -90 to 89 for the numerical EPR experiment :\n");
	printf("# qRotat number_of_lines output_file\n");
	printf("Both arguments are mandatory\n");
	exit(1);
}

int main(int argc, char *argv[])
{

	if (argc != 3 && argc != 4)
	{
		exitHelp();
	}


	int idMax = atoi(argv[1]);
	if (idMax < 10000 || idMax > 1000000000)
	{
		idMax = 1000000;
		printf("The number_of_lines has been changed for %d\n", idMax);
	}
	char fichier[512];
	strcpy(fichier, argv[2]);
	if (!*fichier)
	{
		exitHelp();
	}

	// if there is the 4th argument, the arms will swith between 2 values each
	// idBase is the offset in the 4 hard coded elements table
	// else it will generate uniform random from -90 to 89
	int idBase = 0, doAll = 1;
	if (argc == 4)
	{
		idBase = atoi(argv[3]);
		if (idBase == 0 || idBase == 2)
		{
			doAll = 0;
		}

	}


	// ################################################################################################

	srand((unsigned int)time(NULL)); //  seed48()  and  lcong48()


	FILE *fcb;

	if (!(fcb = fopen(fichier, "w")))
	{
		printf("unable to create the result file %s\n", fichier);
		exit(1);
	}

	// to test doAll once ( today it's just a joke :) )
	if (doAll)
	{
		for (int id = 0; id < idMax; id++)
		{
			fprintf(fcb, "%d\n", randomVarCirc180());
		}
	}
	else
	{
		for (int id = 0; id < idMax; id++)
		{
			fprintf(fcb, "%d\n", randomVarCirc4fromTab(idBase));
		}
	}
	fclose(fcb);
	exit(0);

}